import { MarshallingContext } from "../MarshallingContext";
import { Marshaller } from "../Marshaller";
import { Portable } from "../Portable";
import { UnmarshallingContext } from "../UnmarshallingContext";
export declare abstract class NullableMarshaller<T extends Portable<T>, U, V, X> implements Marshaller<T, U, V, X> {
    marshall(input: T, ctx: MarshallingContext): U | null;
    unmarshall(input: V | undefined, ctx: UnmarshallingContext): X | undefined;
    abstract notNullMarshall(input: T, ctx: MarshallingContext): U;
    abstract notNullUnmarshall(input: V, ctx: UnmarshallingContext): X;
}
